image: microsoft/dotnet:2.1-sdk

stages:
  - test
  - publish

variables:
  ASPNETCORE_ENVIRONMENT: CI
  PACKAGE_NAME: ProSkive.Lib.Common 

unit-tests:
  stage: test
  script:
    - dotnet test ${PACKAGE_NAME}.sln --filter TestCategory~Unit
  except:
    variables:
      - $CI_COMMIT_MESSAGE =~ /^[\[]?[Cc][Hh][Oo][Rr][Ee][\]]?:?.*/
      - $CI_COMMIT_MESSAGE =~ /^[\[]?[Dd][Oo][Cc][Ss][\]]?:?.*/

integration-tests:
  stage: test
  script:
    - dotnet test ${PACKAGE_NAME}.sln --filter TestCategory~Integration
  except:
    variables:
      - $CI_COMMIT_MESSAGE =~ /^[\[]?[Cc][Hh][Oo][Rr][Ee][\]]?:?.*/
      - $CI_COMMIT_MESSAGE =~ /^[\[]?[Dd][Oo][Cc][Ss][\]]?:?.*/

nuget-dev:
  stage: publish
  script:
    - sed -i -e 's/'"${PACKAGE_NAME}"'/'"${PACKAGE_NAME}"'.Preview/g' ./src/${PACKAGE_NAME}.csproj
    - dotnet pack ./src/${PACKAGE_NAME}.csproj -o `pwd`/bin --include-symbols --include-source --version-suffix dev`date +%y%m%d%H%M`
    - PACKAGE=`ls ./bin/ | grep -v 'symbols'`
    - dotnet nuget push ./bin/${PACKAGE} -k ${NUGET_API_KEY} -s https://api.nuget.org/v3/index.json
  only:
    - develop
  except:
    variables:
      - $CI_COMMIT_MESSAGE =~ /^[\[]?[Cc][Hh][Oo][Rr][Ee][\]]?:?.*/
      - $CI_COMMIT_MESSAGE =~ /^[\[]?[Dd][Oo][Cc][Ss][\]]?:?.*/

nuget-prerelease:
  stage: publish
  script:
    - dotnet pack ./src/${PACKAGE_NAME}.csproj -o `pwd`/bin --include-symbols --include-source --version-suffix ${CI_COMMIT_TAG##*-}
    - PACKAGE=`ls ./bin/ | grep -v 'symbols'`
    - dotnet nuget push ./bin/${PACKAGE} -k ${NUGET_API_KEY} -s https://api.nuget.org/v3/index.json
  only:
    - tags
  except:
    variables:
      - $CI_COMMIT_TAG =~ /^\[[Rr][Ee][Ll][Ee][Aa][Ss][Ee]\].*/
      - $CI_COMMIT_TAG =~ /^v(\d)+\.(\d)+\.(\d)+$/

nuget-release:
  stage: publish
  script:
    - dotnet pack ./src/${PACKAGE_NAME}.csproj -o `pwd`/bin --include-symbols --include-source
    - PACKAGE=`ls ./bin/ | grep -v 'symbols'`
    - dotnet nuget push ./bin/${PACKAGE} -k ${NUGET_API_KEY} -s https://api.nuget.org/v3/index.json
  only:
    - master